'use strict';
function getContext(pageCtx, selector) {
  var ctx = pageCtx;
  if (!ctx) {
    var pages = getCurrentPages();
    ctx = pages && pages[pages.length - 1];
  }
  return ctx.selectComponent(selector);
}
function ComponentCtx(pageCtx, selector) {
 
}

function checkData(data) {
  if(!data) {
    return
  }
  if(!data.baseUrl) {
    delete data.baseUrl
  }
  if(!data.identityId) {
    delete data.identityId
  }
}

function isPageObject(object) {
  return object && '__data__' in object && 'triggerEvent' in object && 'setData' in object && '__route__' in object;
}

function ConsentComponent(pageCtx, selector, options) {
  checkData(options)
  var componentCtx = new ComponentCtx(pageCtx, selector);
  if(componentCtx) {
    if(options) {
      var context = getContext(pageCtx, selector);
      if(context) {
        // 初始化组件数据信息
        context.setData(options);
      }
    }
    const globalPageCtx = pageCtx;


    componentCtx.setData = function(pPageCtx, pOptions) {
      var options = isPageObject(pPageCtx)?pOptions:pPageCtx;
      var pageCtx = isPageObject(pPageCtx)?pPageCtx:null;
      checkData(options)

      var componentCtx = getContext(pageCtx?pageCtx:globalPageCtx, selector);
      if (!componentCtx) {
        console.error('[Consents SDK] 无法找到对应的' + selector + '组件，请于页面中注册并在 wxml 中声明自定义'  + selector + '组件');
        return;
      }
      componentCtx.setData(options);
    }

    componentCtx.show = function(pPageCtx, pOptions) {
      var options = isPageObject(pPageCtx)?pOptions:pPageCtx;
      var pageCtx = isPageObject(pPageCtx)?pPageCtx:null;
      checkData(options)

      var componentCtx = getContext(pageCtx?pageCtx:globalPageCtx, selector);
      if (!componentCtx) {
        console.error('[Consents SDK] 无法找到对应的' + selector + '组件，请于页面中注册并在 wxml 中声明自定义'  + selector + '组件');
        return;
      }
      componentCtx.setData(Object.assign({
        show: true
      }, options));
    }
    componentCtx.close = function(pPageCtx, pOptions) {
      var options = isPageObject(pPageCtx)?pOptions:pPageCtx;
      var pageCtx = isPageObject(pPageCtx)?pPageCtx:null;
      checkData(options)

      var componentCtx = getContext(pageCtx?pageCtx:globalPageCtx, selector);
      if (!componentCtx) {
        console.error('[Consents SDK] 无法找到对应的' + selector + '组件，请于页面中注册并在 wxml 中声明自定义'  + selector + '组件');
        return;
      }
      componentCtx.setData(Object.assign({
        show: false
      }, options));
    }
    return componentCtx;
  }
}

module.exports = ConsentComponent;

