const apiBehavior = require('../../business');

Component({
  behaviors: [apiBehavior],
  data: {
    mode: "center"
  },
  methods: {
    onOpenUrl: function name(event) {
      this.triggerEvent('openurl', event.detail)
    },
    onButtonSave: function (event) {
      const consents = this.reportPurposeStatus();
      if(typeof this.data.onConfirm !== "function" || !(this.data.onConfirm(consents) == true)) {
        this.setData({
          show: false
        });
      } 
      this.triggerEvent('confirm', consents);
    },
    onSwitchChanged: function (event) {
      this.setPurposeStatus(event.detail.value, event.detail.id);
      this.triggerEvent('switch');
    },
    requestConfig: function() {
      if(!this.data.requestConfig && this.data.identityId && this.data.appId) {
        this.data.requestConfig = true;
        if (!this.data.enable) {
          
          this.requestAppConfig({
            success: function(data) {
              if(typeof this.data.identityId === "string" && this.data.identityId.length > 0) {
                this.queryPurposeStatus({
                  success: (data) => {
                    this.setData({
                      enable: true,
                      requestConfig: false
                    })
                    this.triggerEvent('load', data)
                    if(typeof this.data.onLoad === "function") {
                      this.data.onLoad(data)
                    } 
                  },
                  fail: (err) => {
                    this.setData({
                      enable: false,
                      requestConfig: false
                    })
                  }
                });
              }
              
            }.bind(this)
          });
        }
      }
    }, 
  },
  observers: {
    'show': function(value) {
      if(value && !this.data.seen) {
        this.reportSeenPurposeStatus({
          success: (data) => {
            this.data.seen = true;
          }
        })
      }
    },
    "appId": function(value) {
      this.requestConfig();
    },
    "identityId": function(value) {
      this.requestConfig();
    }
  }
})