var WxParse = require('../wxParse/wxParse.js')
Component({
  properties: {
    segmentId: {
      type:String,
      value:""
    },
    margin: {
      type:String,
      value:""
    },
    marginLeft: {
      type:String,
      value:""
    },
    marginRight: {
      type:String,
      value:""
    },
    marginTop: {
      type:String,
      value:""
    },
    marginBottom: {
      type:String,
      value:""
    },
    padding: {
      type:String,
      value:""
    },
    paddingLeft: {
      type:String,
      value:""
    },
    paddingRight: {
      type:String,
      value:""
    },
    paddingTop: {
      type:String,
      value:""
    },
    paddingBottom: {
      type:String,
      value:""
    },
    backgroundColor: {
      type: String,
      value: '#F7F8FA'
    },
    titleIconColor: {
      type: String,
      value: '#ED7B2F'
    },
    title: {
      type: String,
      value: '业务必要'
    },
    titleSize: {
      type: String,
      value: '30rpx'
    },
    titleColor: {
      type: String,
      value: '#1A263B'
    },
    detail: {
      type: String,
      value: ''
    },
    detailSize: {
      type: String,
      value: '24rpx'
    },
    detailColor: {
      type: String,
      value: '#6C7482'
    },
    expandable: {
      type: Boolean,
      value: false
    },
    switchable: {
      type: Boolean,
      value: true
    },
    switchChecked: {
      type: Boolean,
      value: false
    },
    switchColor: {
      type: String,
      value: '#ED7B2F'
    },
    background: {
      type: String,
      value: ''
    },
    detailMaxHeightPercent: {
      type: Number,
      value: -1,
    }
  },
  data: {
    expandDetail: true,
    scrollMaxHeight: ''
  },
  observers: {
    "detailMaxHeightPercent": function(newValue) {
      const wHeight = wx.getSystemInfoSync().windowHeight;
      if(wHeight && wHeight > 0) {
        if(newValue > 0) {
          this.setData({
            scrollMaxHeight: (wHeight * newValue) + 'px'
          })
        } else {
          this.setData({
            scrollMaxHeight: (wHeight * 0.6) + 'px' // 默认0.6
          })
        }
      }
    }
  },
  methods: {
    wxParseTagATap: function(event) {
      this.triggerEvent('openurl', {
        url: event.currentTarget.dataset.src
      })
    },
    onSwitchChanged: function(event) {
      this.triggerEvent('switch', {value: event.detail.value, id: this.properties.segmentId});
    },
    onHeadClick: function(event) {
      if(this.properties.expandable) {
        const newStatus = !this.data.expandDetail;
        this.setData({
          expandDetail: newStatus
        });
        this.triggerEvent('expand', {
          expanded: newStatus,
          segmentId: this.properties.segmentId
        })
      }
    }
  },
  lifetimes: {
    attached () {
      if(this.data.detail) {
        var that = this;
        WxParse.wxParse('article', 'html', this.data.detail, that, 0);
      }
    
    } 
  },
})